Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecSbac.cpp
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecSbac.cpp	(revision 193)
@@ -636,13 +636,20 @@
   uiNumCand = pcCU->getSlice()->getMaxNumMergeCand();
 #if HHI_MPI
-#if VSP_TEXT_ONLY
+#if VSP_N
   TComDataCU* pcTextCU = pcCU->getSlice()->getSPS()->getUseMVI() ? pcCU->getSlice()->getTexturePic()->getCU( pcCU->getAddr() ) : NULL;
   Int aiRefIdxVsp[2] = { pcTextCU ? pcTextCU->getCUMvField( RefPicList(0) )->getRefIdx( uiAbsPartIdx ) : -1,
                          pcTextCU ? pcTextCU->getCUMvField( RefPicList(1) )->getRefIdx( uiAbsPartIdx ) : -1 };
-  const Bool bMVIAvailable = pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE
-    && !( aiRefIdxVsp[0] >= 0 && pcTextCU->getSlice()->getRefViewId( RefPicList(0), aiRefIdxVsp[0] ) == NUM_VIEW_VSP )
-    && !( aiRefIdxVsp[1] >= 0 && pcTextCU->getSlice()->getRefViewId( RefPicList(1), aiRefIdxVsp[1] ) == NUM_VIEW_VSP );
-#else
-  const Bool bMVIAvailable = pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE;
+#if VSP_CFG
+  const Bool bMVIAvailable = (pcCU->getSlice()->getSPS()->getVspDepthPresentFlag() || pcCU->getSlice()->getViewId()==0) 
+                                ? pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE 
+                                : pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE
+                                  && !( aiRefIdxVsp[0] >= pcCU->getSlice()->getNumRefIdx( RefPicList(0) ) )
+                                  && !( aiRefIdxVsp[1] >= pcCU->getSlice()->getNumRefIdx( RefPicList(1) ) );
+#else
+  const Bool bMVIAvailable = pcCU->getSlice()->getVspDepthDisableFlag() ? pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE
+                                                                          && !( aiRefIdxVsp[0] >= 0 && pcTextCU->isVspRef( RefPicList(0), aiRefIdxVsp[0] ) )
+                                                                          && !( aiRefIdxVsp[1] >= 0 && pcTextCU->isVspRef( RefPicList(1), aiRefIdxVsp[1] ) ) 
+                                                                        : pcCU->getSlice()->getSPS()->getUseMVI() && pcCU->getSlice()->getSliceType() != I_SLICE;
+#endif
 #endif
   const UInt uiMviMergePos = bMVIAvailable ? HHI_MPI_MERGE_POS : uiNumCand;
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecSlice.cpp
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecSlice.cpp	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecSlice.cpp	(revision 193)
@@ -102,9 +102,4 @@
   rpcPic->setPicYuvResi( 0 );
   
-#if DEBUGLOGOUT
-  char fname[128];
-  sprintf(fname, "%sV%02d_%05d%s.csv", "DecLog", rpcPic->getSlice(0)->getViewId(), rpcPic->getPOC(), rpcPic->getSlice(0)->getIsDepth() ? "depth":"text");
-  m_pcCuDecoder->m_cDebug.DebugLogFileOpen( fname );
-#endif
 #if ENC_DEC_TRACE
   g_bJustDoIt = g_bEncDecTraceEnable;
@@ -444,7 +439,4 @@
 #endif
   }
-#if DEBUGLOGOUT
-  m_pcCuDecoder->m_cDebug.DebugLogFileClose();
-#endif
 
 }
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecTop.cpp	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibDecoder/TDecTop.cpp	(revision 193)
@@ -541,5 +541,4 @@
   }
 #endif
-
 }
 
@@ -986,5 +985,4 @@
         m_pcPicVSP->create( m_apcSlicePilot->getSPS()->getPicWidthInLumaSamples(), m_apcSlicePilot->getSPS()->getPicHeightInLumaSamples(), g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth );
         m_pcPicVSP->setCurrSliceIdx(0);
-        m_pcPicVSP->getCurrSlice()->setViewId( NUM_VIEW_VSP );
         m_pcPicVSP->getCurrSlice()->setViewOrderIdx( m_apcSlicePilot->getSPS()->getViewOrderIdx() );
         m_pcPicVSP->getCurrSlice()->setSPS( m_apcSlicePilot->getSPS() );
@@ -1013,5 +1011,4 @@
         m_pcPicAvail->create( m_apcSlicePilot->getSPS()->getPicWidthInLumaSamples(), m_apcSlicePilot->getSPS()->getPicHeightInLumaSamples(), g_uiMaxCUWidth, g_uiMaxCUHeight, g_uiMaxCUDepth );
         m_pcPicAvail->setCurrSliceIdx(0);
-        m_pcPicAvail->getCurrSlice()->setViewId( 99 );
         m_pcPicAvail->getCurrSlice()->setViewOrderIdx( m_apcSlicePilot->getSPS()->getViewOrderIdx() );
         m_pcPicAvail->getCurrSlice()->setSPS( m_apcSlicePilot->getSPS() );
@@ -1302,6 +1299,8 @@
 #if VSP_N
     Bool bUseVsp = (m_viewId!=0);
-#if VSP_TEXT_ONLY
-    if( m_isDepth ) bUseVsp = false;
+#if VSP_CFG
+    if( !pcSlice->getSPS()->getVspDepthPresentFlag() && m_isDepth ) bUseVsp = false;
+#else
+    if( pcSlice->getVspDepthDisableFlag() && m_isDepth ) bUseVsp = false;
 #endif
 #if VSP_SLICE_HEADER
@@ -1312,5 +1311,8 @@
     if( bUseVsp )
 #endif
+    {
       m_pcPicVSP->getCurrSlice()->setPOC( pcPic->getPOC() );
+      m_pcPicVSP->getCurrSlice()->setViewId( pcPic->getViewId() );
+    }
 
     pcSlice->setRefPicListMvc( m_cListPic, apcInterViewRefPics, bUseVsp ? m_pcPicVSP : NULL );
@@ -1423,5 +1425,17 @@
   if( getTAppDecTop()->getUseDepth() )
   {
-    getTAppDecTop()->storeVSPInBuffer( m_pcPicVSP, m_pcPicAvail, pcSlice->getViewId(), pcSlice->getSPS()->getViewOrderIdx(), pcSlice->getPOC(), m_isDepth );
+#if VSP_CFG
+    if( pcSlice->getSPS()->getVspDepthPresentFlag() || !m_isDepth )
+#else
+    if( !pcSlice->getVspDepthDisableFlag() || !m_isDepth )
+#endif
+      getTAppDecTop()->storeVSPInBuffer( m_pcPicVSP, m_pcPicAvail, pcSlice->getViewId(), pcSlice->getSPS()->getViewOrderIdx(), pcSlice->getPOC(), m_isDepth );
+#if VSP_N_DUMP
+    if( m_pcPicVSP && pcSlice->getViewId() != 0 && pcSlice->getNumRefIdx(REF_PIC_LIST_0)!=0){
+        Char acFilenameBase[1024];
+        ::sprintf(acFilenameBase,"ref_dec_%sv%d_%04d.yuv",(m_isDepth?"D":"T"),pcSlice->getViewId(), pcSlice->getPOC());
+        pcSlice->getRefPic(REF_PIC_LIST_0, pcSlice->getNumRefIdx(REF_PIC_LIST_0)-1)->getPicYuvRec()->dump(acFilenameBase,0);
+    }
+#endif
   }
 #endif
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncCavlc.cpp
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 193)
@@ -695,4 +695,16 @@
     WRITE_FLAG( 1, "base_view_flag" );   
   }
+#if VSP_N
+  if( pcSPS->getViewId() )
+  {
+    WRITE_FLAG( pcSPS->getVspPresentFlag(), "vsp_present_flag" );
+#if VSP_CFG
+    if( pcSPS->getVspPresentFlag() )
+    {
+      WRITE_FLAG( pcSPS->getVspDepthPresentFlag(), "vsp_depth_present_flag" );
+    }
+#endif
+  }
+#endif
   WRITE_FLAG( 0, "sps_extension2_flag" );
 }
@@ -707,4 +719,9 @@
 #if ENC_DEC_TRACE  
   xTraceSliceHeader (pcSlice);
+#endif
+
+#if VSP_CFG
+  Int iNumOfVspRefsL0 = 0;
+  Int iNumOfVspRefsL1 = 0;
 #endif
 
@@ -949,9 +966,42 @@
     }
 
+#if VSP_SLICE_HEADER && VSP_CFG
+    if( pcSlice->getSPS()->getViewId()!=0 
+     && pcSlice->getSliceType() != I_SLICE
+     && pcSlice->getSPS()->getVspPresentFlag()
+      )
+    {
+      if( !pcSlice->getSPS()->isDepth() || pcSlice->getSPS()->getVspDepthPresentFlag() )
+      {
+        WRITE_UVLC( pcSlice->getNumVspRefPics(), "num_vsp_ref_pics");
+        for( UInt i = 0; i < pcSlice->getNumVspRefPics(); i++ )
+        {
+          WRITE_UVLC( pcSlice->getVspRefPos( REF_PIC_LIST_0, i ), "vsp_ref_list0_pos");
+          if( pcSlice->getSliceType() == B_SLICE )
+          {
+            WRITE_UVLC( pcSlice->getVspRefPos( REF_PIC_LIST_1, i ), "vsp_ref_list1_pos");
+          }
+        }
+        iNumOfVspRefsL0 = ( (pcSlice->getSPS()->getViewId()==0 
+                         || (!pcSlice->getSPS()->getVspDepthPresentFlag() && pcSlice->getSPS()->isDepth()) 
+                         || !pcSlice->getVspFlag() 
+                         || pcSlice->getVspRefPos(REF_PIC_LIST_0, 0) == 0 ) ? 0 : 1 );
+        iNumOfVspRefsL1 = ( (pcSlice->getSPS()->getViewId()==0 
+                         || (!pcSlice->getSPS()->getVspDepthPresentFlag() && pcSlice->getSPS()->isDepth()) 
+                         || !pcSlice->getVspFlag() 
+                         || pcSlice->getVspRefPos(REF_PIC_LIST_1, 0) == 0 ) ? 0 : 1 );
+      }
+    }
+#endif
+
     // we always set num_ref_idx_active_override_flag equal to one. this might be done in a more intelligent way 
     if (!pcSlice->isIntra())
     {
       WRITE_FLAG( 1 ,                                             "num_ref_idx_active_override_flag");
+#if VSP_CFG
+      WRITE_CODE( pcSlice->getNumRefIdx( REF_PIC_LIST_0 ) - 1 - iNumOfVspRefsL0, 3, "num_ref_idx_l0_active_minus1" );
+#else
       WRITE_CODE( pcSlice->getNumRefIdx( REF_PIC_LIST_0 ) - 1, 3, "num_ref_idx_l0_active_minus1" );
+#endif
     }
     else
@@ -961,5 +1011,9 @@
     if (pcSlice->isInterB())
     {
+#if VSP_CFG
+      WRITE_CODE( pcSlice->getNumRefIdx( REF_PIC_LIST_1 ) - 1 - iNumOfVspRefsL1, 3, "num_ref_idx_l1_active_minus1" );
+#else
       WRITE_CODE( pcSlice->getNumRefIdx( REF_PIC_LIST_1 ) - 1, 3, "num_ref_idx_l1_active_minus1" );
+#endif
     }
     else
@@ -1050,5 +1104,9 @@
     if(pcSlice->getRefPicListCombinationFlag())
     {
+#if VSP_CFG
+      WRITE_UVLC( pcSlice->getNumRefIdx(REF_PIC_LIST_C) - 1 - iNumOfVspRefsL0,          "num_ref_idx lc_active_minus1");
+#else
       WRITE_UVLC( pcSlice->getNumRefIdx(REF_PIC_LIST_C) - 1,          "num_ref_idx lc_active_minus1");
+#endif
       
 #if H0412_REF_PIC_LIST_RESTRICTION
@@ -1180,16 +1238,19 @@
 #endif
 
+#if !VSP_CFG
 #if VSP_SLICE_HEADER
   if( pcSlice->getSPS()->getViewId()!=0 
-#if VSP_TEXT_ONLY
-      && !(pcSlice->getSPS()->isDepth()) 
-#endif
+   && pcSlice->getSPS()->getVspPresentFlag()
     )
   {
     WRITE_FLAG( pcSlice->getVspFlag()?1:0, "vsp_flag" );
 //    printf("[VSP: %d] ", pcSlice->getVspFlag()?1:0);
-  }
-#endif
-
+    if( pcSlice->getVspFlag() )
+    {
+      WRITE_FLAG( pcSlice->getVspDepthDisableFlag()?1:0 , "vsp_depth_disable_flag" );
+    }
+  }
+#endif
+#endif
 }
 
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncCfg.h
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncCfg.h	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncCfg.h	(revision 193)
@@ -67,4 +67,10 @@
   Int m_interViewRefPosL0[MAX_NUM_REF_PICS];
   Int m_interViewRefPosL1[MAX_NUM_REF_PICS];
+#if VSP_CFG
+  Int m_numVSPRefPics;
+  Int m_VSPRefPics[MAX_NUM_REF_PICS];
+  Int m_VSPRefPosL0[MAX_NUM_REF_PICS];
+  Int m_VSPRefPosL1[MAX_NUM_REF_PICS];
+#endif
  GOPEntryMvc()
   : m_POC(-1)
@@ -81,4 +87,7 @@
   , m_numRefIdc()
   , m_numInterViewRefPics()
+#if VSP_CFG
+  , m_numVSPRefPics()
+#endif
   {
     ::memset( m_referencePics, 0, sizeof(m_referencePics) );
@@ -88,4 +97,9 @@
     ::memset( m_interViewRefPosL0, 0, sizeof(m_interViewRefPosL0) );
     ::memset( m_interViewRefPosL1, 0, sizeof(m_interViewRefPosL1) );
+#if VSP_CFG
+    ::memset( m_VSPRefPics,  0, sizeof(m_VSPRefPics) );
+    ::memset( m_VSPRefPosL0, 0, sizeof(m_VSPRefPosL0) );
+    ::memset( m_VSPRefPosL1, 0, sizeof(m_VSPRefPosL1) );
+#endif
   }
 };
@@ -204,4 +218,10 @@
   Double    m_dLambdaScaleVSO;
   UInt      m_uiVSOMode;
+#if LGE_WVSO_A0119
+  Bool      m_bUseWVSO;
+  Int       m_iVSOWeight;
+  Int       m_iVSDWeight;
+  Int       m_iDWeight;
+#endif
 #endif
 #if SAIT_VSO_EST_A0033
@@ -210,4 +230,8 @@
 #endif
 
+#if VSP_SLICE_HEADER
+  Bool      m_bUseVSP;
+  Bool      m_bVSPDepthDisable;
+#endif
 
   //====== Tool list ========
@@ -266,5 +290,8 @@
   Int       m_iColumnRowInfoPresent;
   Int       m_iUniformSpacingIdr;
+#if FIX_REMOVE_TILE_DEPENDENCE
+#else
   Int       m_iTileBoundaryIndependenceIdr;
+#endif
   Int       m_iNumColumnsMinus1;
   UInt*     m_puiColumnWidth;
@@ -281,5 +308,5 @@
   Int       m_iWaveFrontSubstreams;
 
-  bool m_pictureDigestEnabled; ///< enable(1)/disable(0) md5 computation and SEI signalling
+  Bool      m_pictureDigestEnabled; ///< enable(1)/disable(0) md5 computation and SEI signalling
 
   //====== Weighted Prediction ========
@@ -309,5 +336,9 @@
 #endif
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
-  Bool      m_bUseDMM;
+  Bool     m_bUseDMM;
+#endif
+
+#if OL_DEPTHLIMIT_A0044
+  Bool     m_bDepthPartitionLimiting;
 #endif
 
@@ -466,4 +497,10 @@
   Void      setAllowNegDist                 ( Bool b  )     { m_bAllowNegDist     = b; };
 #endif
+#if LGE_WVSO_A0119
+  Void      setUseWVSO                      ( Bool  b )     { m_bUseWVSO   = b; }
+  Void      setVSOWeight                    ( Int   i )     { m_iVSOWeight = i; }
+  Void      setVSDWeight                    ( Int   i )     { m_iVSDWeight = i; }
+  Void      setDWeight                      ( Int   i )     { m_iDWeight   = i; }
+#endif
 #endif
 
@@ -546,4 +583,10 @@
   Bool      getAllowNegDist                 ()      { return m_bAllowNegDist;     }
 #endif
+#if LGE_WVSO_A0119
+  Bool      getUseWVSO                      ()      { return m_bUseWVSO;     }
+  Int       getVSOWeight                    ()      { return m_iVSOWeight;    }
+  Int       getVSDWeight                    ()      { return m_iVSDWeight;    }
+  Int       getDWeight                      ()      { return m_iDWeight;    }
+#endif
 #endif
 
@@ -571,4 +614,9 @@
 #if HHI_VSO
   Void      setUseVSO                       ( Bool  b )     { m_bUseVSO     = b; }
+#endif
+
+#if VSP_SLICE_HEADER
+  Void      setUseVSP                       ( Bool  b )     { m_bUseVSP     = b; }
+  Void      setVSPDepthDisable              ( Bool  b )     { m_bVSPDepthDisable = b; }
 #endif
 
@@ -623,4 +671,9 @@
 #endif
 
+#if VSP_SLICE_HEADER
+  Bool      getUseVSP                       ()      { return m_bUseVSP; }
+  Bool      getVSPDepthDisable              ()      { return m_bVSPDepthDisable; }
+#endif
+
   Bool      getUseFastEnc                   ()      { return m_bUseFastEnc; }
   Bool      getUseEarlyCU                   ()      { return m_bUseEarlyCU; }
@@ -657,12 +710,12 @@
   Void  setSliceGranularity            ( Int  i )      { m_iSliceGranularity = i;       }
   Int   getSliceGranularity            ()              { return m_iSliceGranularity;    }
-  Void      setLFCrossSliceBoundaryFlag     ( Bool   bValue  )    { m_bLFCrossSliceBoundaryFlag = bValue; }
-  Bool      getLFCrossSliceBoundaryFlag     ()                    { return m_bLFCrossSliceBoundaryFlag;   }
+  Void  setLFCrossSliceBoundaryFlag    ( Bool   bValue  )    { m_bLFCrossSliceBoundaryFlag = bValue; }
+  Bool  getLFCrossSliceBoundaryFlag    ()                    { return m_bLFCrossSliceBoundaryFlag;   }
 
 #if HHI_MPI
-  Void      setUseMVI                  (Bool bVal)     {m_bUseMVI = bVal;}
-#endif
-  Void      setUseSAO                  (Bool bVal)     {m_bUseSAO = bVal;}
-  Bool      getUseSAO                  ()              {return m_bUseSAO;}
+  Void  setUseMVI                      ( Bool bVal )   {m_bUseMVI = bVal;}
+#endif
+  Void  setUseSAO                      ( Bool bVal )   {m_bUseSAO = bVal;}
+  Bool  getUseSAO                      ()              {return m_bUseSAO;}
 #if SAO_UNIT_INTERLEAVING
   Void  setMaxNumOffsetsPerPic                   (Int iVal)            { m_maxNumOffsetsPerPic = iVal; }
@@ -795,6 +848,11 @@
 
 #if HHI_DMM_WEDGE_INTRA || HHI_DMM_PRED_TEX
-  Void setUseDMM( Bool b) { m_bUseDMM = b;    }
-  Bool getUseDMM()        { return m_bUseDMM; }
+  Void      setUseDMM( Bool b) { m_bUseDMM = b;    }
+  Bool      getUseDMM()        { return m_bUseDMM; }
+#endif
+
+#if OL_DEPTHLIMIT_A0044
+  Void      setUseDPL(Bool b) {m_bDepthPartitionLimiting = b; }
+  Bool      getUseDPL()       {return m_bDepthPartitionLimiting;}
 #endif
 
Index: /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncCu.cpp
===================================================================
--- /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncCu.cpp	(revision 192)
+++ /branches/HTM-4.0.1-VSP-dev0/source/Lib/TLibEncoder/TEncCu.cpp	(revision 193)
@@ -451,8 +451,38 @@
   TComPic* pcPic = rpcBestCU->getPic();
 
+#if OL_DEPTHLIMIT_A0044
+  TComSPS *sps = pcPic->getSlice(0)->getSPS();
+  TComPic *pcTexture;
+  TComDataCU * pcTextureCU;
+  Bool  depthMapDetect =  false;
+  //UInt         uiPrevTexPartIndex = 0;
+#if OL_DO_NOT_LIMIT_INTRA_SLICES_PART
+  Bool bIntraSliceDetect = false;
+#endif
+  Bool bTry2NxN = false;
+  Bool bTryNx2N = false;
+    pcTexture = rpcBestCU->getSlice()->getTexturePic();
+    if(pcTexture != NULL) //depth map being encoded
+    {
+    depthMapDetect = true;
+#if OL_DO_NOT_LIMIT_INTRA_SLICES_PART
+      bIntraSliceDetect = (rpcBestCU->getSlice()->getSliceType()==I_SLICE);
+#endif
+    if(uiDepth == 0)
+    {
+      pcTextureCU = pcTexture->getCU( rpcBestCU->getAddr() );
+      pcTexture->setPartInfo(pcTextureCU->readPartInfo());
+      pcTexture->setTexPartIndex(0); 
+    }
+    }
+    else
+    {
+      depthMapDetect = false;
+    }
+#endif
   // get Original YUV data from picture
   m_ppcOrigYuv[uiDepth]->copyFromPicYuv( pcPic->getPicYuvOrg(), rpcBestCU->getAddr(), rpcBestCU->getZorderIdxInCU() );
 #if FORCE_REF_VSP
-  //Bool bWholeCUCanBeSynthesized = false;
+  Bool bWholeCUCanBeSynthesized = false;
   //Bool bOneSubCUCanNotBeSynthesied = false;
   Bool bSubCUCanBeSynthesized[4];
@@ -476,5 +506,5 @@
     if(iSubCUCanBeSynthesizedCnt == 4)
     {
-      //bWholeCUCanBeSynthesized = true;
+      bWholeCUCanBeSynthesized = true;
     }
     //else if(iSubCUCanBeSynthesizedCnt == 3)
@@ -488,5 +518,5 @@
   // variables for fast encoder decision
   Bool    bEarlySkip  = false;
-  Bool    bTrySplit    = true;
+  Bool    bTrySplit   = true;
   Double  fRD_Skip    = MAX_DOUBLE;
 
@@ -499,5 +529,5 @@
   Bool    bTrySplitDQP  = true;
 
-  static  Double  afCost[ MAX_CU_DEPTH ];
+  static  Double  afCost [ MAX_CU_DEPTH ];
   static  Int      aiNum [ MAX_CU_DEPTH ];
 
@@ -581,5 +611,5 @@
       isAddLowestQP = true; 
       iMinQP = iMinQP - 1;
-       
+
     }
 #endif
@@ -624,4 +654,78 @@
 
       rpcTempCU->initEstData( uiDepth, iQP );
+
+#if OL_DEPTHLIMIT_A0044
+      //logic for setting bTrySplit using the partition information that is stored of the texture colocated CU
+#if OL_DO_NOT_LIMIT_INTRA_SLICES_PART
+      if(depthMapDetect && !bIntraSliceDetect && sps->getUseDPL())
+#else
+      if(depthMapDetect && sps->getUseDPL()) //depth map being encoded
+#endif
+      {
+        assert(uiDepth == pcTexture->accessPartInfo(1));
+        if(pcTexture->accessPartInfo(0) == 1) //NxN modes
+        {
+          bTrySplit = true;
+          bTryNx2N = true;
+          bTry2NxN = true;
+          //uiPrevTexPartIndex = pcTexture->getTexPartIndex(); 
+          pcTexture->incrementTexPartIndex(); 
+        }
+        else if(pcTexture->accessPartInfo(0) == 0) //2Nx2N modes
+        {
+          UInt uiTexdepth;
+          UInt temp_uiTexPartIndex;
+          bTrySplit = false;
+
+          //scan ahead till next depth
+          uiTexdepth = pcTexture->accessPartInfo(1);
+          //uiPrevTexPartIndex = pcTexture->getTexPartIndex(); 
+          pcTexture->incrementTexPartIndex();
+          temp_uiTexPartIndex = pcTexture->getTexPartIndex(); //store in case to rewind
+
+          while(uiTexdepth != pcTexture->accessPartInfo(1) && uiTexdepth != 0)
+          {
+            if(pcTexture->accessPartInfo(1) < uiTexdepth)
+            {
+              break;
+            }
+            pcTexture->incrementTexPartIndex(); 
+
+            if(pcTexture->accessPartInfo(1) == OL_END_CU)
+            {
+              pcTexture->setTexPartIndex(temp_uiTexPartIndex); 
+              uiTexdepth++;
+              if(uiTexdepth >= g_uiMaxCUDepth)
+              {      
+                break;
+              }
+            }
+          }
+        }
+        else if(pcTexture->accessPartInfo(0) == OL_END_CU)
+        {
+          bTrySplit = false;
+          bTryNx2N = false;
+          bTry2NxN = false;
+        }
+        else if(pcTexture->accessPartInfo(0) == 2) //2NxN case
+        {
+          bTrySplit = false;
+          bTryNx2N = false;
+          bTry2NxN = true;
+          //uiPrevTexPartIndex = pcTexture->getTexPartIndex();  
+          pcTexture->incrementTexPartIndex(); ;
+        }
+        else if(pcTexture->accessPartInfo(0) == 3) //Nx2N case
+        {
+          bTrySplit = false;
+          bTryNx2N = true;
+          bTry2NxN = false;
+          //uiPrevTexPartIndex = pcTexture->getTexPartIndex();  
+          pcTexture->incrementTexPartIndex(); ;
+        }
+      }
+#endif
+
 
       // do inter modes, SKIP and 2Nx2N
@@ -648,63 +752,96 @@
 #endif
 #if HHI_INTER_VIEW_RESIDUAL_PRED
-        rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
-#endif
-        // SKIP
-#if HHI_INTERVIEW_SKIP
-        xCheckRDCostMerge2Nx2N( rpcBestCU, rpcTempCU, bFullyRenderedSec );
-#else
-        xCheckRDCostMerge2Nx2N( rpcBestCU, rpcTempCU );
-#endif
-        rpcTempCU->initEstData( uiDepth, iQP );
-
-        // fast encoder decision for early skip
-        if ( m_pcEncCfg->getUseFastEnc() )
+          rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
+#endif
+          // SKIP
+#if HHI_INTERVIEW_SKIP
+          xCheckRDCostMerge2Nx2N( rpcBestCU, rpcTempCU, bFullyRenderedSec );
+#else
+          xCheckRDCostMerge2Nx2N( rpcBestCU, rpcTempCU );
+#endif
+          rpcTempCU->initEstData( uiDepth, iQP );
+
+          // fast encoder decision for early skip
+          if ( m_pcEncCfg->getUseFastEnc() )
+          {
+            Int iIdx = g_aucConvertToBit[ rpcBestCU->getWidth(0) ];
+            if ( aiNum [ iIdx ] > 5 && fRD_Skip < EARLY_SKIP_THRES*afCost[ iIdx ]/aiNum[ iIdx ] )
+            {
+              bEarlySkip = true;
+              bTrySplit  = false;
+            }
+          }
+
+          // 2Nx2N, NxN
+          if ( !bEarlySkip )
+          {
+#if HHI_INTER_VIEW_RESIDUAL_PRED
+            rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
+#endif
+#if HHI_INTERVIEW_SKIP
+            xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2Nx2N, bFullyRenderedSec );
+
+#else
+            xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2Nx2N );
+#endif
+            rpcTempCU->initEstData( uiDepth, iQP );
+            if(m_pcEncCfg->getUseCbfFastMode())
+            {
+              doNotBlockPu = rpcBestCU->getQtRootCbf( 0 ) != 0;
+            }
+
+#if FORCE_REF_VSP==1
+#if VSP_CFG
+            if( rpcBestCU->getSlice()->getSPS()->getVspDepthPresentFlag() || !rpcBestCU->getSlice()->getSPS()->isDepth() )
+#else
+            if( !rpcBestCU->getSlice()->getVspDepthDisableFlag() || !rpcBestCU->getSlice()->getSPS()->isDepth() )
+#endif
+            if( bWholeCUCanBeSynthesized )
+            {
+#if HHI_INTER_VIEW_RESIDUAL_PRED
+              rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
+#endif
+#if HHI_INTERVIEW_SKIP
+              xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2Nx2N, bFullyRenderedSec, false, true ); // VSP
+#else
+              xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2Nx2N );
+#endif
+              rpcTempCU->initEstData( uiDepth, iQP );
+            }
+#else
+            if( bWholeCUCanBeSynthesized ) // To avoid compiling warning
+            {
+            }
+#endif
+          }
+#if HHI_INTER_VIEW_RESIDUAL_PRED
+        } // uiResPrdId
+#endif
+      } // != I_SLICE
+
+#if OL_DEPTHLIMIT_A0044
+#if OL_DO_NOT_LIMIT_INTRA_SLICES_PART
+      if(depthMapDetect && !bIntraSliceDetect  && sps->getUseDPL())
+#else
+      if(depthMapDetect  && sps->getUseDPL()) //depth map being encoded
+#endif
+      {
+        bTrySplitDQP = bTrySplit;
+      }
+      else
+      {
+        if( (g_uiMaxCUWidth>>uiDepth) >= rpcTempCU->getSlice()->getPPS()->getMinCuDQPSize() )
         {
-          Int iIdx = g_aucConvertToBit[ rpcBestCU->getWidth(0) ];
-          if ( aiNum [ iIdx ] > 5 && fRD_Skip < EARLY_SKIP_THRES*afCost[ iIdx ]/aiNum[ iIdx ] )
+          if(iQP == iBaseQP)
           {
-            bEarlySkip = true;
-            bTrySplit  = false;
+            bTrySplitDQP = bTrySplit;
           }
         }
-
-        // 2Nx2N, NxN
-        if ( !bEarlySkip )
+        else
         {
-#if HHI_INTER_VIEW_RESIDUAL_PRED
-          rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
-#endif
-#if HHI_INTERVIEW_SKIP
-            xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2Nx2N, bFullyRenderedSec );
-
-#else
-            xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2Nx2N );
-#endif
-          rpcTempCU->initEstData( uiDepth, iQP );
-          if(m_pcEncCfg->getUseCbfFastMode())
-          {
-            doNotBlockPu = rpcBestCU->getQtRootCbf( 0 ) != 0;
-          }
-
-#if FORCE_REF_VSP==1
-#if VSP_TEXT_ONLY
-          if( !rpcBestCU->getSlice()->getSPS()->isDepth() )
-#endif
-#if HHI_INTER_VIEW_RESIDUAL_PRED
-            rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
-#endif
-#if HHI_INTERVIEW_SKIP
-            xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2Nx2N, bFullyRenderedSec, false, true ); // VSP
-#else
-            xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2Nx2N );
-#endif
-            rpcTempCU->initEstData( uiDepth, iQP );
-#endif
+          bTrySplitDQP = bTrySplit;
         }
-#if HHI_INTER_VIEW_RESIDUAL_PRED
-        } // uiResPrdId
-#endif
-      } // != I_SLICE
-
+      }
+#else
 
       if( (g_uiMaxCUWidth>>uiDepth) >= rpcTempCU->getSlice()->getPPS()->getMinCuDQPSize() )
@@ -719,4 +856,5 @@
         bTrySplitDQP = bTrySplit;
       }
+#endif
 #if LOSSLESS_CODING
       if (isAddLowestQP && (iQP == lowestQP))
